@echo off
cd /d "%~dp0"
color 0e
title mRatio Fixer v7 / Multiple Instance Patcher

if not exist busybox.--- (
	title mRatio Fixer v7 / Error
	echo busybox.--- is missing.
	goto exit
)

rem Cheap (but effective) method of checking for administrator privileges
net session 1>nul 2>&1 && goto main
title mRatio Fixer v7 / Error
echo This script requires administrator privileges. To run it, you should:
echo   * Right-click on %~nx0
echo   * Click on "Run as administrator"
echo   * Click on "Yes" in the User Account Control prompt
echo.
echo Press any key to exit...&pause >nul&exit /b

:main
echo This will patch mRatio to allow multiple instances by changing the
echo unique ID it uses to detect them. Effectively, it creates a "new",
echo separate executable that will only block additional instances of itself
echo while ignoring the official version (or other patched copies). Please
echo keep a few things in mind:
echo   * You must have an _unmodified_ copy of mRatio.exe version 5.4.1 in
echo     the same directory as this script.
echo   * The output of this procedure will be named mRatio-XXXXXXXXXXXX.exe,
echo     where XXXXXXXXXXXX is a randomly-generated 12-character string.
echo   * While more likely to be reliable than the instance unlocker, the
echo     stability of this patch is not guaranteed.
echo   * Each patched instance you run _must_ be installed in a separate
echo     directory to prevent conflicts arising from sharing configuration
echo     files. It's up to you to enforce this.
echo   * Listen ports cannot be shared among instances, but in practice this
echo     doesn't matter much because mRatio only binds to a port to complete
echo     a TCP handshake and appear connectable on the tracker, no
echo     application data is sent.
echo   * As long as you follow the advice above, you can create and run as
echo     many patched executables as you want. 
echo.
:prompt
choice /c yn /n /m "Do you want to patch the executable now? (y/n)"
if %ERRORLEVEL%==1 echo Okay, continuing.&goto next
if %ERRORLEVEL%==2 goto exit
echo Invalid choice, press a key and try again.
pause >nul
goto prompt

:next
if not exist mRatio.exe (
	title mRatio Fixer v7 / Error
	echo mRatio.exe is missing.
	goto exit
)

for /f "usebackq tokens=1 delims= " %%a in (`busybox.--- sha256sum mRatio.exe`) do (
	if not "%%a"=="61b211f7626e097dfd1de493a3599e4a97d68ad88486e28a74d3faf8f355c403" (
		title mRatio Fixer v7 / Error
		echo This isn't mRatio 5.4.1's original executable. Make sure you provide an
		echo unmodified version. The file in question has a July 2015 timestamp and
		echo can be downloaded at http://www.sb-innovation.de/showthread.php?t=31194
		goto exit
		)
	)

echo Generating unique ID...
SetLocal EnableDelayedExpansion
echo %RANDOM% >nul & echo %RANDOM% >nul & echo %RANDOM% >nul & echo %RANDOM% >nul & echo %RANDOM% >nul
set MASK=abcdef0123456789
set MASKLEN=16
set LEN=12
call :getChar

echo Done, creating patched executable "mRatio-%OUT%.exe"...
copy /y "mRatio.exe" "mRatio-%OUT%.exe.tmp" 1>nul 2>&1
busybox.--- echo -ne "%OUT%" | busybox.--- dd of="mRatio-%OUT%.exe.tmp" seek=726001 oflag=seek_bytes conv=notrunc status=none
ren "mRatio-%OUT%.exe.tmp" "mRatio-%OUT%.exe"

echo All done.

:exit
SetLocal DisableDelayedExpansion
set MASK=
set MASKLEN=
set LEN=
set OUT=
set INDEX=
echo Press any key to exit...
pause >nul
exit /b

rem Thanks to tallberg at https://jakash3.wordpress.com/2009/10/18/random-string-generator-bat/#comment-321
:getChar
set /a INDEX=%RANDOM%*%MASKLEN%/32767
set OUT=%OUT%!MASK:~%INDEX%,1!
set /a LEN-=1
if %LEN% GTR 0 goto getChar
