@echo off
cd /d "%~dp0"
color 0e
title mRatio Fixer v7 / Certificate Installer

for %%a in (mitmproxy-dhparam.pem mitmproxy-ca-cert.pem mitmproxy-ca-cert.p12 mitmproxy-ca-cert.cer mitmproxy-ca.pem mitmproxy-ca.p12) do if not exist %%a (
	title mRatio Fixer v7 / Error
	echo One or more certificate files are missing.
	echo Before running this script, you must open start.bat ^(to generate the
	echo root certificate^) first.
	goto exit
)

rem Cheap (but effective) method of checking for administrator privileges
net session 1>nul 2>&1 && goto main
title mRatio Fixer v7 / Error
echo This script requires administrator privileges. To run it, you should:
echo   * Right-click on %~nx0
echo   * Click on "Run as administrator"
echo   * Click on "Yes" in the User Account Control prompt
echo.
echo Press any key to exit...&pause >nul&exit /b

:main
echo Making sure there is no mitmproxy certificate in the Trusted Root CAs store...
certutil -delstore "Root" "mitmproxy" 1>nul 2>&1
echo Installing mitmproxy root certificate...
certutil -addstore "Root" mitmproxy-ca-cert.cer 1>nul 2>&1
echo Done.
goto exit

:exit
echo Press any key to exit...
pause >nul
exit /b
